;--------------------------------------------------------------------------------
;	PIC16F690E3F\ԑv Programmed by GRANADA
;	Ver 1.0		2010/07/07 ` PIC16F687 3F\dvx[XɉρAiF臒lύX\o[WjAJ
;	Ver 2.0		2010/08/04 ` RA2/INTݔŁAxx̕\EύX\o[WiF臒l͌ŒɁjAHUD \ΉA
;							@iݒ葬x\j
;	Ver 3.0		2010/08/05 ` PORTA ԕωݔŁAx@\폜Ao[\AgAsڍsΉA1st release
;	Ver 3.1		2010/08/18	HUD  7 ZOp^[f[^C
;	Ver 3.2		2010/08/23	HUD  7 ZOp^[f[^ďC
;	i{\[XvO̓^u4ɐݒ肷Yɐ`܂j
;	LF http://www.asahi-net.or.jp/~SE1M-NITU/html/3color_Speed_Meter.htm
;--------------------------------------------------------------------------------

	LIST		P=16F690
	INCLUDE		P16F690.INC

	ERRORLEVEL	-205
	ERRORLEVEL	-302

	__CONFIG _FCMEN_OFF & _CP_OFF & _CPD_OFF & _BOR_ON & _PWRTE_ON & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT & _IESO_OFF & _WDT_OFF

;--------------------------------------------------------------------------------
;	ϐAhX`
;--------------------------------------------------------------------------------

CBLOCK	H'20'			; [U[pt@CWX^iϐ̈j擪AhX

	PULSE_IN			; xMJEgiݏŉZj
	FREQ				; xMJEgiC[`ŎQƂ郌WX^j
	PREV_FREQ			; ݕ\̃f[^igj

	ORANGE_MIN			; F\JnXs[hiǒlj
	ORANGE_MAX			; F\IXs[hiǒlj

	SPEED				; Xs[hi10iǒl Km/hj

	BCD_H				; BCD ϊl
	BCD_M				; BCD ϊl
	BCD_L				; BCD ϊl

	PATTERN_H			; ʃrbgp^[E}X^[p^[
	PATTERN_M			; ʃrbgp^[E}X^[p^[
	PATTERN_L			; ʃrbgp^[E}X^[p^[

	SEGMENT				; \rbgp^[

	USER_FLAG			; etO
	COLOR_FLAG			; xF̐ptO, bit = 1  _

	TMP					; Gp[N
	MASK_PATTERN		; LED o[Ag}XNp^[p

	LED					; _o[ LED ̌

	HIGHWAY_TMR			; [hڍsJE^

ENDC

CBLOCK	H'70'			; SoNʃt@CWX^擪AhX

	W_WORK				; 荞ݎ W WX^ޔp
	ST_WORK				; 荞ݎ̃Xe[^XWX^ޔp

	GATE_COUNTER		; ݉񐔌vpJE^[

	COUNTER1			; ԑ҂p
	COUNTER2			; ԑ҂p
	COUNTER3			; ԑ҂p

ENDC

;--------------------------------------------------------------------------------
;	萔`, DEFINE g MPLAB SIM ̃t@CWX^_vɕ֗
;	it@CWX^ɒ萔ꍞ܂Ȃj
;--------------------------------------------------------------------------------

#DEFINE		GATE_TIME			D'2'	;  TMR1 ݂ŃpXJEg邩 (250ms x 2 = 0.5sec)

#DEFINE		FACTOR1				D'143'	; gxϊW1i140Km܂ōő덷 2Km/hj
#DEFINE		FACTOR2				D'100'	; gxϊW2

#DEFINE		ORANGE_MIN_NORMAL	D'70'	; ʓEF\Jn (Km/h)
#DEFINE		ORANGE_MAX_NORMAL	D'99'	; ʓEF\I (Km/h)

#DEFINE		ORANGE_MIN_HIGHWAY	D'100'	; [hEF\Jn (Km/h)
#DEFINE		ORANGE_MAX_HIGHWAY	D'119'	; [hEF\I (Km/h)

;--------------------------------------------------------------------------------
;	|[g`
;--------------------------------------------------------------------------------
;RA0	LEDo[0	DIGITAL_OUT		LED o[̌o
;RA1	LEDo[1	DIGITAL	OUT
;RA2	LEDo[2	DIGITAL	OUT
;RA5	LEDo[3	DIGITAL OUT

;RA3	ԑM	DIGITAL	IN		ԑNbN

;RB4	G1			DIGITAL	OUT
;RB5	G2			DIGITAL OUT
;RB6	G3			DIGITAL OUT

;RC0	R1			DIGITAL	OUT
;RC1	R2			DIGITAL OUT
;RC2	R3			DIGITAL OUT

;RB7	LED a		DIGITAL OUT
;RC7	LED b		DIGITAL OUT
;RC6	LED c		DIGITAL OUT
;RC3	LED d		DIGITAL OUT
;RC4	LED e		DIGITAL OUT
;RC5	LED f		DIGITAL OUT
;RA4	LED g		DIGITAL OUT

#DEFINE		CLK_IN		3				; ԑNbN̓|[gԍ
#DEFINE		CLK_PORT	PORTA,CLK_IN	; ԑNbN̓|[g`

#DEFINE		BAR0		0				; LED o[ւ̏o
#DEFINE		BAR1		1				; LED o[ւ̏o
#DEFINE		BAR2		2				; LED o[ւ̏o
#DEFINE		BAR3		5				; LED o[ւ̏o

#DEFINE		GREEN_BIT		COLOR_FLAG,0	; FtÕrbgԍ
#DEFINE		RED_BIT			COLOR_FLAG,1	; FtÕrbgԍ

#DEFINE		MEAS_OK			USER_FLAG,0		; 1 = f[^擾
#DEFINE		HUD_MODE		USER_FLAG,1		; 1 = HUD \[h
#DEFINE		HIGH_SPEED		USER_FLAG,2		; 1 = s
#DEFINE		HIGHWAY_MODE	USER_FLAG,3		; 1 = s[h

#DEFINE		R1			0		; PORTC
#DEFINE		R2			1		; PORTC
#DEFINE		R3			2		; PORTC

#DEFINE		G1			4		; PORTB
#DEFINE		G2			5		; PORTB
#DEFINE		G3			6		; PORTB

#DEFINE		G1_PORT	PORTB,G1
#DEFINE		G2_PORT	PORTB,G2
#DEFINE		G3_PORT	PORTB,G3

#DEFINE		R1_PORT	PORTC,R1
#DEFINE		R2_PORT	PORTC,R2
#DEFINE		R3_PORT	PORTC,R3

#DEFINE		A_SEG	PORTB,7		; LED  a ZOg̃|[gԍ
#DEFINE		B_SEG	PORTC,7		; LED  b ZOg̃|[gԍ
#DEFINE		C_SEG	PORTC,6		; LED  c ZOg̃|[gԍ
#DEFINE		D_SEG	PORTC,3		; LED  d ZOg̃|[gԍ
#DEFINE		E_SEG	PORTC,4		; LED  e ZOg̃|[gԍ
#DEFINE		F_SEG	PORTC,5		; LED  f ZOg̃|[gԍ
#DEFINE		G_SEG	PORTA,4		; LED  g ZOg̃|[gԍ

;--------------------------------------------------------------------------------
;	}N`
;--------------------------------------------------------------------------------

BANK0	macro
		BCF		STATUS,RP1
		NOP
		BCF		STATUS,RP0
		endm

BANK1	macro
		BCF		STATUS,RP1
		NOP
		BSF		STATUS,RP0
		endm

BANK2	macro
		BSF		STATUS,RP1
		NOP
		BCF		STATUS,RP0
		endm

BANK3	macro
		BSF		STATUS,RP1
		NOP
		BSF		STATUS,RP0
		endm

;--------------------------------------------------------------------------------
;	vO擪
;--------------------------------------------------------------------------------

	ORG		H'0'
	GOTO	INITIALIZE

;--------------------------------------------------------------------------------
;	荞ݏ
;--------------------------------------------------------------------------------

	ORG		H'4'			; 荞ݏ擪AhX

	MOVWF	W_WORK			; WX^Ҕ
	SWAPF	STATUS,W		; Z tOeȂ悤AMOVF ł͂Ȃ SWAPF gp
	MOVWF	ST_WORK			; STATUS WX^ۑ Bank A\

;
;	݌`FbN
;

	BTFSS	PIR1,CCP1IF		; TMR1 compare special event triger  ?
	GOTO	CHK_PORT_CNG	; Ⴄ
;
;	TMR1 RyAݏ
;
	BCF		PIR1,CCP1IF		; Special event triger ݃tONA

;
;	Q[g^Co߂
;

CHK_GATE_TIME:

	DECFSZ	GATE_COUNTER,F
	GOTO	CHK_PORT_CNG	; ̊݃`FbN
;
;	Q[g^Coߖ̏
;
	MOVF	PULSE_IN,W
	MOVWF	FREQ			; Cœǂݏoϐɑޔ

	CALL	CLEAR_PARAM		; JE^

	BTFSC	HIGHWAY_MODE	; s[h ?
	GOTO	CHK_PORT_CNG	; ɍs[hȂ̂ŉȂ

	BTFSS	HIGH_SPEED		; ʏ푖s[hȂ猻ݍs ?
	GOTO	CHK_PORT_CNG	; ʏ푬xősȂ̂ŉȂ

	DECFSZ	HIGHWAY_TMR,F	; s[hJE^JEg_E
	GOTO	CHK_PORT_CNG	; ܂莞Ԍo߂ĂȂ

	CALL	CLEAR_HW_TMR2	; JE^Đݒ

	CALL	SET_HIGHWAYW_MODE	; s[hֈڍs
;
;	|[gω荞݃`FbN
;

CHK_PORT_CNG:

	BTFSS	INTCON,RABIF	; ԕω݃tOĂ邩
	GOTO	POP_REG			; ĂȂ

;
;	|[gԕωݏ
;

	MOVF	PORTA,W			; |[gǂݏoătONȀ
	BCF		INTCON,RABIF	; ԕω݃tONA

	BTFSC	CLK_PORT		; オ肩 ?
	INCF	PULSE_IN,F		; オȂ̂ŃNbNJEgAbv

POP_REG:					; WX^A`荞ݏI

	SWAPF	ST_WORK,W
	MOVWF	STATUS
	SWAPF	W_WORK,F
	SWAPF	W_WORK,W

	RETFIE					; 荞ݏI

;--------------------------------------------------------------------------------
;	1̐7ZOgrbgp^[Ԃ
;--------------------------------------------------------------------------------

GET_7SEG_PATTERN:				;	ʏ\p

	ADDWF	PCL,F
;              gfedcba
	RETLW	B'00111111'	;	0
	RETLW	B'00000110'	;	1
	RETLW	B'01011011'	;	2
	RETLW	B'01001111'	;	3
	RETLW	B'01100110'	;	4
	RETLW	B'01101101'	;	5
	RETLW	B'01111101'	;	6
	RETLW	B'00100111'	;	7
	RETLW	B'01111111'	;	8
	RETLW	B'01101111'	;	9

GET_7SEG_PATTERN_HUD:			;	HUD \p

	ADDWF	PCL,F
;              gfedcba

;								 LED ʏzuɂĂ܂ꍇ
;	RETLW	B'00111111'	;	0
;	RETLW	B'00000110'	;	1
;	RETLW	B'01101101'	;	2
;	RETLW	B'01001111'	;	3
;	RETLW	B'01010110'	;	4
;	RETLW	B'01011011'	;	5
;	RETLW	B'01111011'	;	6
;	RETLW	B'00011110'	;	7
;	RETLW	B'01111111'	;	8
;	RETLW	B'01011111'	;	9

;								HUD Wzȕꍇ
	RETLW	B'00111111'	;	0
	RETLW	B'00110000'	;	1
	RETLW	B'01101101'	;	2
	RETLW	B'01111001'	;	3
	RETLW	B'01110010'	;	4
	RETLW	B'01011011'	;	5
	RETLW	B'01011111'	;	6
	RETLW	B'00110011'	;	7
	RETLW	B'01111111'	;	8
	RETLW	B'01111011'	;	9

;--------------------------------------------------------------------------------
; Lϊe[u̓AZuAhX100ԒnɎ߂邱ƁI
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	vOX^[g
;--------------------------------------------------------------------------------

INITIALIZE:

	BANKSEL	PORTA			; Bank 0
	CLRF	PORTA			; ALL LED OFF
	CLRF	PORTB
	CLRF	PORTC

	BANKSEL	OSCCON			; Bank 1
	MOVLW	B'01110100'		; NbN 8MHz ɐݒibit 3 ݒ肪 16F88 ƈقȂ_ɒӁj
	MOVWF	OSCCON

	CLRF	PIE1			; Bank 1, 荞݂͂ЂƂ܂Sĕs

	CLRF	TRISA			; Bank 1, ЂƂ܂S|[go͂Ɏw
	CLRF	TRISB			; Bank 1
	CLRF	TRISC			; Bank 1
;									 iԑM|[g͓͌ŒȂ̂œ͎wsvj
	BANK2					; macro

	CLRF	ANSEL			; Bank 2, S|[gfW^ɐݒ
	CLRF	ANSELH			; Bank 2

;--------------------------------------------------------------------------------
;	TMR1 ݒ, RyA@\g 250ms 荞݂ɐݒ
;--------------------------------------------------------------------------------

	BANKSEL	PIE1			; Bank1
	BCF		PIE1,TMR1IE		; TMR1 I[o[t[荞݂͕siÔ߁j

	BANKSEL	INTCON			; Bank0
	CLRF	INTCON			; Bank0A܂荞݂͋Ȃ

	CLRF	TMR1H			; TMR1 NA
	CLRF	TMR1L

	MOVLW	B'00001011'		; Campare mode with Special event triger enable
	MOVWF	CCP1CON			; Bank0

	MOVLW	H'F4'			; &HF424 = 62500A0.5us x 62500 = 31.25ms
	MOVWF	CCPR1H			; Bank0
	MOVLW	H'23'			;  1 ĂȂƂȂ炵
	MOVWF	CCPR1L			; Bank0, vXP[ƕ 31.25 x 8 = 250ms Ŋ荞ݔ

	MOVLW	B'00110100'		; vXP[ 1:8 ɐݒB31.25ms x 8 = 250ms Ɋ݂
	MOVWF	T1CON			; Bank0

;--------------------------------------------------------------------------------
;	̑ݒ
;--------------------------------------------------------------------------------

	BANK0

	CLRF	FREQ
	MOVLW	D'1'
	MOVWF	PREV_FREQ		; f[^ɕ\悤ɂĂ
	CLRF	SPEED

	CALL	CLEAR_PARAM		; ݊֌Wϐ
	CALL	CLEAR_HW_TMR	; s[hڍsJE^

	CLRF	USER_FLAG		; etO
	CLRF	COLOR_FLAG		; \FtO

	CLRF	PATTERN_H		; uN\ŃX^[g
	CLRF	PATTERN_M
	CLRF	PATTERN_L

	BSF		HUD_MODE		; HUD [hɐݒiʏ\Ȃ炱̍sRgAEgj

;--------------------------------------------------------------------------------
;	ݏJn
;--------------------------------------------------------------------------------

	BANKSEL	IOCA			; Bank1
	CLRF	IOCA			; Bank1
	BSF		IOCA,CLK_IN		; Bank1, ԕω݃|[gw

	BSF		PIE1,CCP1IE		; Bank1, RyA݋

	BANKSEL	INTCON			; Bank0
	BSF		INTCON,RABIE	; Bank0, PORTA ԕω݋
	BSF		INTCON,PEIE		; Bank0, ӊ (e.g. RA2 INT) 
	BSF		INTCON,GIE		; Bank0, S̊荞݋
	BSF		T1CON, TMR1ON	; Bank0, TMR1 X^[g

;--------------------------------------------------------------------------------
;	C[vJn
;--------------------------------------------------------------------------------

	CALL	WAIT_1sec
	CALL	WAIT_1sec
	CALL	WAIT_1sec		; ҂ĂX^[gi˓dh~j

MAIN_LOOP:

;
;	Xs[hlω`FbN
;

CHK_CHANGE:

	MOVF	FREQ,W
	MOVWF	TMP				; FREQ ޔiɊ荞ݑ FREQ j

	MOVF	PREV_FREQ,W
	SUBWF	TMP,W			; FREQ - PREV_FREQ -> W

	BTFSC	STATUS,Z		; Z=0 Ȃf[^ω
	GOTO	MAIN2			; Z=1 Ńf[^ς炸Ȃ̂ł̂܂܂̒lŕ\s
;
;	Xs[hlω
;

UPDATE:

	MOVF	TMP,W
	MOVWF	PREV_FREQ		; `FbNpf[^ۑ

	CALL	CONV_DATA		; gxϊ
	CALL	SET_PARAMETERS	; \

MAIN2:

;
;	sx`FbN
;

	MOVLW	D'80'
	SUBWF	SPEED,W			; SPEED - 80 -> W
	BTFSC	STATUS,C		; if SPEED < 80, C=0
	GOTO	H_SPEED			; s

	BCF		HIGH_SPEED		; stONA
	CALL	CLEAR_HW_TMR	; s[hڍs^C}[NA
	GOTO	MAIN3

H_SPEED:

	BSF		HIGH_SPEED		; stO𗧂Ă
;
;	Xs[h\
;

MAIN3:

	CALL	DISPLAY			; LED _Ci~bN_

	GOTO	MAIN_LOOP

;--------------------------------------------------------------------------------
;	ȉTu[`Q
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	LED \ZOgp^[A\F̌
;
;	IN		SPEED			xi10iǒl, Km/hj
;
;	RETURN	COLOR_FLAG		J[tOirbgj
;			PATTERN_H		ʂ̃ZOgp^[
;			PATTERN_M		ʂ̃ZOgp^[
;			PATTERN_L		ʂ̃ZOgp^[
;--------------------------------------------------------------------------------

SET_PARAMETERS:

	CLRF	COLOR_FLAG		; Frbg
	CLRF	PATTERN_H		; \p^[
	CLRF	PATTERN_M		; \p^[
	CLRF	PATTERN_L		; \p^[

	CLRF	prm1b			; ʃNA
	MOVF	SPEED,W			; SPEED = 10iǒl Ȃ̂ŉ8bitm
	MOVWF	prm1a			; ʃZbg

	CALL	HEX2DEC16		; 16bitl -> 5 BCD ϊ
							; X^bNƕϐی̂ߊ荞݂͖ɂĂ

	MOVF	prm3a,W			; BCD
	MOVWF	BCD_L			; XgA
	MOVF	prm3b,W			; BCD 
	MOVWF	BCD_M			; XgA
	MOVF	prm3c,W			; BCD 
	MOVWF	BCD_H			; XgA

;--------------------------------------------------------------------------------
;	LEDo[̌vZ`}XNp^[̍쐬
;--------------------------------------------------------------------------------

	MOVF	SPEED,W
	MOVWF	A1				; q

	MOVLW	D'10'
	MOVWF	B1				; 

	CALL	DIV8			; in Math16_v2.lib

;
;	78
;
	MOVLW	D'8'
	SUBWF	B1,W			; B1 = ]艺 8bit, B1 - 8 -> W
	BTFSC	STATUS,C		; if ] < 8, C=0
	INCF	A1,F			; ]肪8ȏȂ_悹

	MOVF	A1,W			; ǂݏo
	MOVWF	LED				; _ LED ̌ޔ
;
;	NbsO
;
	MOVLW	D'14'
	SUBWF	LED,W			; LED - 14 -> W
	BTFSS	STATUS,C		; if LED >= 14, C=1
	GOTO	MAKE_MASK_PATTERN

	MOVLW	D'14'
	MOVWF	LED				; 14 ȏȂ␳

MAKE_MASK_PATTERN:

	MOVF	LED,W
	MOVWF	MASK_PATTERN	; bit 0,1,2 ͈ʒu␳g

	BCF		MASK_PATTERN,3	; 4bit ڂ͋NA

	BTFSC	LED,3
	BSF		MASK_PATTERN,BAR3	; LED o̓|[gɍ킹ărbgʒu␳
								; e.g. 15 = 00001111 -> 00100111

;--------------------------------------------------------------------------------
;	\F
;--------------------------------------------------------------------------------

	MOVF	ORANGE_MIN,W
	SUBWF	SPEED,W			; SPEED - ORANGE_MIN(W) -> W
	BTFSS	STATUS,C		; SPEED >= ORANGE_MIN Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	GREEN

	MOVF	ORANGE_MAX,W
	SUBWF	SPEED,W			; SPEED - ORANGE_MAX(W) -> W
	BTFSS	STATUS,C		; SPEED >= ORANGE_MAX Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	ORANGE			; F\
							; ORANGE_MAX ȏȂԕ\

;--------------------------------------------------------------------------------
;	\F̃tO
;--------------------------------------------------------------------------------

RED:						; 

	CALL	SET_RED
	GOTO	GET_LED_PATTERN

GREEN:						; 

	CALL	SET_GREEN
	GOTO	GET_LED_PATTERN

ORANGE:						; 

	CALL	SET_RED
	CALL	SET_GREEN
	GOTO	GET_LED_PATTERN

;--------------------------------------------------------------------------------
;	Frbg̃Zbg
;--------------------------------------------------------------------------------

SET_RED:

	BSF		RED_BIT
	RETURN

SET_GREEN:

	BSF		GREEN_BIT
	RETURN

;--------------------------------------------------------------------------------
;	BCD lɊÂ LED \p^[ɃZbg
;
;	RETURN:	PATTERN_H	ʌZOgp^[
;			PATTERN_M	ʌZOgp^[
;			PATTERN_L	ʌZOgp^[
;--------------------------------------------------------------------------------

GET_LED_PATTERN:

	MOVF	BCD_H,W
	BTFSS	STATUS,Z			; ŏʂ0 ?
	GOTO	SET_H_PATTERN		; 0 łȂ̂Œʏ폈

	CLRF	PATTERN_H			; ŏʂ̓uN

	MOVF	BCD_M,W
	BTFSS	STATUS,Z			; 2ڂ0 ?
	GOTO	SET_M_PATTERN		; 0 łȂ̂Œʏ폈

	CLRF	PATTERN_M			; 2ڂuN

	GOTO	SET_L_PATTERN		; ŏI0ł OK

SET_H_PATTERN:

	MOVF	BCD_H,W				; 100̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_H			; p^[ۑ

SET_M_PATTERN:

	MOVF	BCD_M,W				; 10̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_M			; p^[ۑ

SET_L_PATTERN:

	MOVF	BCD_L,W				; 1̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_L			; p^[ۑ

	RETURN

;--------------------------------------------------------------------------------
;	7ZO\p^[𓾂iHUDΉj
;	IN:		WiBCDlj
;	RETURN:	W (ZOgp^[j
;--------------------------------------------------------------------------------

GET_PATTERN:

	BTFSC	HUD_MODE			; 1 = HUD [h
	GOTO	GET_HUD_DATA

	CALL	GET_7SEG_PATTERN
	RETURN

GET_HUD_DATA:

	CALL	GET_7SEG_PATTERN_HUD
	RETURN

;--------------------------------------------------------------------------------
;	_Ci~bN_
;	PATTERN_H	ʌZOgp^[
;	PATTERN_M	ʌZOgp^[
;	PATTERN_L	ʌZOgp^[
;--------------------------------------------------------------------------------

DISPLAY:

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED1 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
;	BCF		G1_PORT				; H  ON (L=_)
	BSF		G1_PORT				; H  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
;	BCF		R1_PORT				; H  ON (L=_)
	BSF		R1_PORT				; H  ON (H=_)

	MOVF	PATTERN_H,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED2 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
;	BCF		G2_PORT				; M  ON (L=_)
	BSF		G2_PORT				; M  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
;	BCF		R2_PORT				; M  ON (L=_)
	BSF		R2_PORT				; M  ON (H=_)

	MOVF	PATTERN_M,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED3 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
;	BCF		G3_PORT				; L  ON (L=_)
	BSF		G3_PORT				; L  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
;	BCF		R3_PORT				; L  ON (L=_)
	BSF		R3_PORT				; L  ON (H=_)

	MOVF	PATTERN_L,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

;	CALL	ALL_LED_OFF			; S

	RETURN

;--------------------------------------------------------------------------------
;	ZOg
;	IN: W = rbgp^[
;--------------------------------------------------------------------------------

SEG_A:

	MOVWF	SEGMENT				; ZOgp^[ۑĂ

	BTFSS	SEGMENT,0			; a ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_B				; ̃ZOg

	BSF		A_SEG				; a ZOg_
	CALL	HOLD_LED
	BCF		A_SEG				; a ZOg
	CALL	HOLD_LED_SHORT

SEG_B:

	BTFSS	SEGMENT,1			; b ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_C				; ̃ZOg

	BSF		B_SEG				; b ZOg_
	CALL	HOLD_LED
	BCF		B_SEG				; b ZOg
	CALL	HOLD_LED_SHORT

SEG_C:

	BTFSS	SEGMENT,2			; c ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_D				; ̃ZOg

	BSF		C_SEG				; c ZOg_
	CALL	HOLD_LED
	BCF		C_SEG				; c ZOg
	CALL	HOLD_LED_SHORT

SEG_D:

	BTFSS	SEGMENT,3			; d ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_E				; ̃ZOg

	BSF		D_SEG				; d ZOg_
	CALL	HOLD_LED
	BCF		D_SEG				; d ZOg
	CALL	HOLD_LED_SHORT

SEG_E:

	BTFSS	SEGMENT,4			; e ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_F				; ̃ZOg

	BSF		E_SEG				; e ZOg_
	CALL	HOLD_LED
	BCF		E_SEG				; e ZOg
	CALL	HOLD_LED_SHORT

SEG_F:

	BTFSS	SEGMENT,5			; f ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_G				; ̃ZOg

	BSF		F_SEG				; f ZOg_
	CALL	HOLD_LED
	BCF		F_SEG				; f ZOg
	CALL	HOLD_LED_SHORT

SEG_G:

	BTFSS	SEGMENT,6			; g ZOgrbg 1 Ȃ玟̖߂XLbv
	RETURN						; \I

	BSF		G_SEG				; g ZOg_
	CALL	HOLD_LED
	BCF		G_SEG				; g ZOg
	CALL	HOLD_LED_SHORT

	RETURN						; SZOgI

;--------------------------------------------------------------------------------
;	LED \莞ԕێi߁j
;--------------------------------------------------------------------------------

HOLD_LED:

	CALL	WAIT_100us

	RETURN

;--------------------------------------------------------------------------------
;	LED \莞ԕێiZ߁j
;--------------------------------------------------------------------------------

HOLD_LED_SHORT:

	CALL	WAIT_5us

	RETURN

;--------------------------------------------------------------------------------
;	LED SiSZOgA|[g L = OFFj
;--------------------------------------------------------------------------------

ALL_LED_OFF:

	MOVF	MASK_PATTERN,W		; LED o[ւ̏o͂ OFF Ȃ悤Ƀ}XNp^[ǂݏo
	MOVWF	PORTA				; PORTA ɔf

	CLRF	PORTB
	CLRF	PORTC

	RETURN

;--------------------------------------------------------------------------------
;	gxϊ
;	IN:		TMP ( = FREQ l)
;	RETURN:	SPEEDi10iǒl Km/hj
;
;	tBbg̎ԑM 4pXi637x4pX/1KmjȂ̂ŁAx(Km/h) = g(Hz) x 1.4128
;	8bit x 8bit ŌvZ܂A\̃Lǂ悤 1.43 ɂĒlۂ߂B
;	i140Km/h ܂łȂ덷͍ő 2Km/h Ɏ܂j
;	tBbg̎ԑpX 24pin I[fBIRlN^ 15pinijBׂ 14pin  ACC
;--------------------------------------------------------------------------------

CONV_DATA:

	BCF		STATUS,C
	RLF		TMP,F			; 2{ɂăJEggɕϊ

	CLRF	A1
	MOVF	TMP,W			; pXJEgi8bitjǂݏo
	MOVWF	A2

	CLRF	B1
	MOVLW	FACTOR1			; 8bit
	MOVWF	B2

	CALL	MUL16			; in Math16.lib
							; 8bit x 8bit Ȃ̂œ͉ 16bit Ŋm (A1, A2 ͕sv)

	MOVF	B1,W
	MOVWF	A1				; qiʁjXgA
	MOVF	B2,W
	MOVWF	A2				; qiʁjXgA

	CLRF	B1
	MOVLW	FACTOR2			; W2 (8bit) ŊĒǑx𓾂
	MOVWF	B2

	CALL	DIV16			; in Math16.lib, returns A1A2

	MOVF	A2,W			; Ǒx(͉8bit݂̂Ŋm)ۑĂ
	MOVWF	SPEED

	RETURN

;--------------------------------------------------------------------------------
;	݊֌Wϐ̏
;--------------------------------------------------------------------------------

CLEAR_PARAM:

	MOVLW	GATE_TIME			; ݎ x GATE_TIME ŎԑpXJEg
	MOVWF	GATE_COUNTER		; ԃJE^[

	CLRF	PULSE_IN			; ̓JEg

	RETURN

;--------------------------------------------------------------------------------
;	s[hڍsJE^̏AF臒l
;--------------------------------------------------------------------------------

CLEAR_HW_TMR:

	BCF		HIGHWAY_MODE		; s[htONA

	MOVLW	ORANGE_MIN_NORMAL	; ʓ臒lɐݒ
	MOVWF	ORANGE_MIN

	MOVLW	ORANGE_MAX_NORMAL
	MOVWF	ORANGE_MAX

CLEAR_HW_TMR2:

	MOVLW	D'254'				; Q[g^C240i=128bjōs[hɈڍs
	MOVWF	HIGHWAY_TMR

	RETURN

;--------------------------------------------------------------------------------
;	s[h
;--------------------------------------------------------------------------------

SET_HIGHWAYW_MODE:

	BSF		HIGHWAY_MODE		; s[hڍstO𗧂Ă

	MOVLW	ORANGE_MIN_HIGHWAY	; 臒lɐݒ
	MOVWF	ORANGE_MIN

	MOVLW	ORANGE_MAX_HIGHWAY
	MOVWF	ORANGE_MAX

	GOTO	CLEAR_HW_TMR2		; Ô߃JE^[NAĖ߂

;--------------------------------------------------------------------------------
;	Cuǂݍ
;--------------------------------------------------------------------------------

	INCLUDE		Time-8MHz.lib	; NbN8MHzpԑ҂[vCu
	INCLUDE		Math16-v2.lib	; 16bit lZCu

;--------------------------------------------------------------------------------
;	vOI
;--------------------------------------------------------------------------------

	END
